Index: /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.cc
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.cc	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.cc	(revision 2970)
@@ -43,5 +43,25 @@
     {
         RegisterObject(Asteroids);
+        this->firstCheckpointReached_ = false;
+        this->timeLimit_ = 30;
     }
+
+    void Asteroids::tick(float dt)
+    {
+        SUPER(Asteroids, tick, dt);
+ 
+        if (firstCheckpointReached_)
+        {
+            this->timeLimit_ = this->time_;
+            this->startTimer();
+        }
+
+        if (this->time_ < 0 && !this->hasEnded())
+        {
+            this->end();
+        }
+        
+    }
+
 
     void Asteroids::start()
Index: /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.h
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.h	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/gametypes/Asteroids.h	(revision 2970)
@@ -42,6 +42,16 @@
             virtual ~Asteroids() {}
 
+            virtual void tick(float dt);
+
             virtual void start();
             virtual void end();
+           
+            inline void firstCheckpointReached(bool reached)
+              { this->firstCheckpointReached_ = reached; }
+
+        private:
+            bool firstCheckpointReached_;
+            bool gameEnded_;
+
     };
 }
Index: /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.cc
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.cc	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.cc	(revision 2970)
@@ -60,4 +60,8 @@
         this->numberOfBots_ = 0;
 
+        this->timeLimit_ = 0;
+        this->time_ = 0;
+        this->timerIsActive_ = false;
+
         this->initialStartCountdown_ = 3;
 
@@ -87,4 +91,13 @@
     {
         SUPER(Gametype, tick, dt);
+
+        //count timer
+        if (timerIsActive_)
+        {
+            if (this->timeLimit_ == 0)
+                this->time_ += dt;
+            else
+                this->time_ -= dt;
+        }
 
         if (this->gtinfo_.bStartCountdownRunning_ && !this->gtinfo_.bStarted_)
@@ -393,3 +406,30 @@
         }
     }
+
+    void Gametype::addTime(float t)
+    { 
+        if (this->timeLimit_ == 0)
+          this->time_ -= t;
+        else
+          this->time_ += t;
+    }
+
+    void Gametype::removeTime(float t)
+    { 
+        if (this->timeLimit_ == 0)
+          this->time_ += t;
+        else
+          this->time_ -= t;
+    }
+
+    void Gametype::resetTimer()
+    { 
+        this->resetTimer(timeLimit_);
+    }
+
+    void Gametype::resetTimer(float t)
+    { 
+        this->timeLimit_ = t;
+        this->time_ = t;
+    }
 }
Index: /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.h
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.h	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/gametypes/Gametype.h	(revision 2970)
@@ -126,4 +126,22 @@
                 { return this->players_.size(); }
 
+            virtual void addTime(float t);
+            virtual void removeTime(float t);
+
+            inline  void startTimer()
+              { this->timerIsActive_ = true; }
+
+            inline void stopTimer()
+              { this->timerIsActive_ = false; }
+
+            inline float getTime()
+              { return this->time_; }
+
+            inline bool getTimerIsActive()
+              { return timerIsActive_; }
+
+            virtual void resetTimer();
+            virtual void resetTimer(float t);
+
         protected:
             virtual SpawnPoint* getBestSpawnPoint(PlayerInfo* player) const;
@@ -140,4 +158,8 @@
             bool bAutoStart_;
             bool bForceSpawn_;
+
+            float time_;
+            float timeLimit_;
+            bool timerIsActive_;
 
             float initialStartCountdown_;
Index: /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.cc
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.cc	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.cc	(revision 2970)
@@ -47,6 +47,7 @@
 
     this->setStayActive(true);
-    this->setDistance(20);
-    bIsDestination_ = false;
+    this->setDistance(50);
+    this->bIsFirst_ = false;
+    this->bIsDestination_ = false;
     this->setVisible(true);
   }
@@ -60,30 +61,28 @@
     SUPER(CheckPoint, XMLPort, xmlelement, mode);
 
+    XMLPortParam(CheckPoint, "isfirst", setFirst, getFirst, xmlelement, mode).defaultValues(false);
     XMLPortParam(CheckPoint, "isdestination", setDestination, getDestination, xmlelement, mode).defaultValues(false);
+    XMLPortParam(CheckPoint, "addtime", setAddTime, getAddTime, xmlelement, mode).defaultValues(30);
   }
   
-  void CheckPoint::setDestination(bool isDestination)
-  {
-    bIsDestination_ = isDestination;
-  }
-
-  bool CheckPoint::getDestination()
-  {
-    return bIsDestination_;
-  }
-
-
   void CheckPoint::triggered(bool bIsTriggered)
   {
     DistanceTrigger::triggered(bIsTriggered);
 
-    if (bIsTriggered && bIsDestination_)
-    {
-      Asteroids* gametype = dynamic_cast<Asteroids*>(this->getGametype());
-      if (gametype)
-      {
-        gametype->end();
-      }
-    }
+    Asteroids* gametype = dynamic_cast<Asteroids*>(this->getGametype());
+    if (gametype)
+    { 
+        gametype->addTime(addTime_);
+
+        if (bIsTriggered && bIsFirst_)
+        {
+            gametype->firstCheckpointReached(true);
+        }
+     
+        if (bIsTriggered && bIsDestination_)
+        {
+            gametype->end();
+        }
+     }
   }
 }
Index: /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.h
===================================================================
--- /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.h	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/objects/worldentities/triggers/CheckPoint.h	(revision 2970)
@@ -57,8 +57,26 @@
     private:
       virtual void triggered(bool bIsTriggered); 
-      virtual void setDestination(bool isDestination);
-      virtual bool getDestination();	
+
+      inline void setDestination(bool isDestination)
+        { bIsDestination_ = isDestination; }
+
+      inline bool getDestination()
+        { return bIsDestination_; }	
+   
+      inline void setFirst(bool isFirst)
+        { this->bIsFirst_ = isFirst; }
+
+      inline bool getFirst()
+        { return this->bIsFirst_; }
+
+      inline void setAddTime(float time)
+        { this->addTime_ = time; }
+
+      inline bool getAddTime()
+        { return this->addTime_; }
       
+      bool bIsFirst_;
       bool bIsDestination_;
+      float addTime_;
   };
 }
Index: /code/branches/gametypes/src/orxonox/overlays/hud/CMakeLists.txt
===================================================================
--- /code/branches/gametypes/src/orxonox/overlays/hud/CMakeLists.txt	(revision 2969)
+++ /code/branches/gametypes/src/orxonox/overlays/hud/CMakeLists.txt	(revision 2970)
@@ -5,4 +5,5 @@
   HUDSpeedBar.cc
   HUDHealthBar.cc
+  HUDTimer.cc
   ChatOverlay.cc
   GametypeStatus.cc
Index: /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.cc
===================================================================
--- /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.cc	(revision 2970)
+++ /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.cc	(revision 2970)
@@ -0,0 +1,75 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Aurelian Jaggi
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "HUDTimer.h"
+
+#include <OgreTextAreaOverlayElement.h>
+
+#include "core/CoreIncludes.h"
+#include "util/Convert.h"
+#include "objects/infos/GametypeInfo.h"
+#include "objects/infos/PlayerInfo.h"
+#include "objects/worldentities/ControllableEntity.h"
+#include "objects/worldentities/pawns/Spectator.h"
+#include "objects/gametypes/Gametype.h"
+
+namespace orxonox
+{
+  CreateFactory(HUDTimer);
+
+  HUDTimer::HUDTimer(BaseObject* creator) : OverlayText(creator)
+  {
+    RegisterObject(HUDTimer);
+
+    this->owner_ = 0;
+  }
+
+  HUDTimer::~HUDTimer()
+  {
+  }
+
+  void HUDTimer::tick(float dt)
+  {
+    SUPER(HUDTimer, tick, dt);
+
+    Gametype* gametype = this->getGametype();
+
+    if (gametype->getTimerIsActive())
+    {
+      this->setCaption(convertToString((int)gametype->getTime()));
+    }
+  }
+
+  void HUDTimer::changedOwner()
+  { 
+    SUPER(HUDTimer, changedOwner);
+
+    this->owner_ = dynamic_cast<ControllableEntity*>(this->getOwner());
+  }
+}
Index: /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.h
===================================================================
--- /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.h	(revision 2970)
+++ /code/branches/gametypes/src/orxonox/overlays/hud/HUDTimer.h	(revision 2970)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Aurelian Jaggi
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _HUDTimer_H__
+#define _HUDTimer_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "overlays/OverlayText.h"
+#include "objects/Tickable.h"
+
+namespace orxonox
+{
+  class _OrxonoxExport HUDTimer : public OverlayText, public Tickable
+  {
+    public:
+      HUDTimer(BaseObject* creator);
+      ~HUDTimer();
+
+      virtual void tick(float dt);
+
+      virtual void changedOwner();
+
+      private:
+        ControllableEntity* owner_;
+    };
+}
+#endif /* _HUDTimer_H__ */