Index: /code/branches/map/src/orxonox/objects/RadarViewable.cc
===================================================================
--- /code/branches/map/src/orxonox/objects/RadarViewable.cc	(revision 2976)
+++ /code/branches/map/src/orxonox/objects/RadarViewable.cc	(revision 2977)
@@ -117,7 +117,8 @@
 //Vector3 v = this->getRVWorldPosition();
             //this->line_->setPoint(1, Vector3(0,v.y,0) );
-            this->line_->setPoint(1, Vector3(0, -this->getRVWorldPosition().y ,0) );
+            this->line_->setPoint(1, Vector3( 0, (int) -Map::getSingletonPtr()->movablePlane_->getDistance( this->getRVWorldPosition() ) ,0 ));
             this->line_->update();
-            this->LineNode_->setDirection(Vector3::UNIT_Y,Ogre::Node::TS_WORLD,Vector3::UNIT_Y);
+            if( Map::getSingletonPtr()->playerShipNode_ )
+                this->LineNode_->setDirection( Map::getSingletonPtr()->playerShipNode_->getLocalAxes().GetColumn(1) ,Ogre::Node::TS_WORLD,Vector3::UNIT_Y);
         }
     }
Index: /code/branches/map/src/orxonox/overlays/map/Map.cc
===================================================================
--- /code/branches/map/src/orxonox/overlays/map/Map.cc	(revision 2976)
+++ /code/branches/map/src/orxonox/overlays/map/Map.cc	(revision 2977)
@@ -47,4 +47,5 @@
 
 #include <OgreOverlay.h>
+#include <OgreMovablePlane.h>
 #include <OgreOverlayElement.h>
 #include <OgreOverlayManager.h>
@@ -169,8 +170,11 @@
         overlay_->hide();
 
-        //Create plane in map
+        //Create plane to show grid
         Ogre::Entity* plane_ent = Map::getMapSceneManager()->createEntity( "MapPlane", "plane.mesh");
         planeNode_ = Map::getMapSceneManager()->getRootSceneNode()->createChildSceneNode();
-        
+        //Create plane for calculations
+        movablePlane_ = new Ogre::MovablePlane( Vector3::UNIT_Y, 0 );
+        movablePlane_->normalise();
+
         //Ogre::MaterialPtr plane_mat = Ogre::MaterialManager::getSingleton().create("mapgrid", "General");
         //plane_mat->getTechnique(0)->getPass(0)->createTextureUnitState("mapgrid.tga");
@@ -178,5 +182,7 @@
         plane_ent->setMaterialName("Map/Grid");
         planeNode_->attachObject(plane_ent);
+        
         planeNode_->scale(10,1,10);
+        planeNode_->attachObject(movablePlane_);
         //Ogre::Material plane_mat = Ogre::MaterialManager::getSingletonPtr()->getByName("rock");
         
@@ -272,6 +278,6 @@
                 this->Cam_->setPosition(0, 0, DISTANCE);
                 this->Cam_->pitch( (Degree)PITCH );
-                //this->CamNodeHelper_->lookAt(Vector3(0,0,0), Ogre::Node::TS_PARENT);
-                this->Cam_->setAutoTracking(true, this->playerShipNode_);
+                this->Cam_->lookAt(Vector3(0,0,0));
+                //this->Cam_->setAutoTracking(true, this->playerShipNode_);
             }
             
@@ -364,5 +370,5 @@
         Map::singletonMap_s->CamNodeHelper_->lookAt(Vector3(0,0,0), Ogre::Node::TS_PARENT);
 */
-        singletonMap_s->CamNode_->pitch( (Degree)(value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_PARENT);
+        singletonMap_s->CamNode_->pitch( (Degree)(value.y * singletonMap_s->mouseLookSpeed_), Ogre::Node::TS_LOCAL);
         
     }
Index: /code/branches/map/src/orxonox/overlays/map/Map.h
===================================================================
--- /code/branches/map/src/orxonox/overlays/map/Map.h	(revision 2976)
+++ /code/branches/map/src/orxonox/overlays/map/Map.h	(revision 2977)
@@ -38,4 +38,5 @@
 #include <OgreOverlayManager.h>
 #include <OgreOverlayContainer.h>
+#include <OgreMovablePlane.h>
 
 #include <OgreBorderPanelOverlayElement.h>
@@ -114,7 +115,9 @@
         Ogre::SceneNode* playerShipNode_;
         Ogre::SceneNode* planeNode_;
-        
+        Ogre::MovablePlane* movablePlane_;
         int mouseLookSpeed_;
         bool isVisible_;
+     
+    friend class RadarViewable;
     };
 }
Index: /code/branches/map/src/util/SubString.cc
===================================================================
--- /code/branches/map/src/util/SubString.cc	(revision 2976)
+++ /code/branches/map/src/util/SubString.cc	(revision 2977)
@@ -39,4 +39,5 @@
 
 #include "SubString.h"
+#include <stdio.h>
 
 namespace orxonox